//#include <stdlib.h>
#include "macchine.h"


Macchina* newMacchina(int id, char nome[])
{
	Macchina * result;
	
	result = (Macchina *) malloc( sizeof(Macchina) );
	result -> id = id;
	strcpy(result ->nome, nome);

	return result;
}


void destroyMacchina(Macchina *m)
{
	free(m);
	return;
}


Parte* newParte(int id, int idMacchina, char nome[], int costo)
{
	Parte * result;

	result = (Parte *) malloc(sizeof(Parte));
	result->id = id;
	result->idMacchina = idMacchina;
	strcpy(result->nome, nome);
	result->costo = costo;

	return result;
}


void destroyParte(Parte *m)
{
	free(m);
	return;
}



int readField(char buffer[], char sep, FILE *f)
{
	int i = 0;
	char ch = fgetc(f);
	while (ch != sep && ch != 10 && ch != EOF)
	{
		buffer[i++] = ch;
		ch = fgetc(f);
	}
	buffer[i] = '\0';
	return i;
}

Macchina * readMacchina(FILE * fp)
{
	int id;
	char nome[35];
	Macchina * result;

	fscanf(fp, "%d", &id);
	readField(nome, '\0', fp);

	result = newMacchina(id, nome);
	return result;
}


Parte * readParte(FILE * fp)
{
	int id;
	int idMacchina;
	char nome[35];
	int costo;
	Parte * result;

	fscanf(fp, "%d", &id);
	fscanf(fp, "%d", &idMacchina);
	fgetc(fp);
	readField(nome, ';', fp);
	fscanf(fp, "%d", &costo);
	fgetc(fp);

	result = newParte(id, idMacchina, nome, costo);
	return result;
}


